#-----------------------------------------------------------------------------
#
#    Python translation of the contextmenu.rb example.
#
#-----------------------------------------------------------------------------
# Original Google copyright notice:
#
# Copyright 2005-2008, Google, Inc.
#
# This software is provided as an example of using the Ruby interface
# to SketchUp.
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

def selected_arc():
	model = Sketchup.active_model()
	ss = model.selection()
	if not ss.is_is_curve(): # this is a stutering function :)
		return None
	edge = ss.first()
	if not edge.typename() == 'Edge':
		return None
	curve = edge.curve()
	if not curve.typename() == 'ArcCurve':
		return None
	return curve

def point_at_center():
	point = None
	arc = selected_arc()
	if arc:
		point = Sketchup.active_model().active_entities().add_cpoint(arc.center())
	return point

def handler(menu):
	if selected_arc():
		menu.add_separator()
		menu.add_item("Point at Center", body = point_at_center)

import menus
menus.add_context_menu_handler(handler)
